
//http://lazplanet.blogspot.ch/2013/05/a-simple-image-viewer-from-start-to.html
 //http://wiki.lazarus.freepascal.org/Developing_with_Graphics#Painting_on_the_bitmap_of_a_TImage
// Modified M.Weber 03.01.2017
// Lazarus 1.6 auf win XP




unit frm1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls, ComCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnOpen: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    edtImage2Width: TEdit;
    edtImage2Height: TEdit;
    edtSourceRight: TEdit;
    edtSourceBottom: TEdit;
    edtRTop: TEdit;
    edtRLeft: TEdit;
    edtRRight: TEdit;
    edtRBottom: TEdit;
    edtYFactor: TEdit;
    edtXFactor: TEdit;
    edtXSize: TEdit;
    edtYSize: TEdit;
    edtZoom: TEdit;
    edtImageWidth: TEdit;
    edtImageHeight: TEdit;
    Image1: TImage;
    Image2: TImage;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lblXSize: TLabel;
    lblYSize: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    ScrollBox1: TScrollBox;
    ScrollBox2: TScrollBox;
    trkXSize: TTrackBar;
    trkYSize: TTrackBar;
    TrkZoom: TTrackBar;
    procedure btnOpenClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure edtImage2WidthChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    procedure trkXSizeChange(Sender: TObject);
    procedure trkYSizeChange(Sender: TObject);

    procedure TrkZoomChange(Sender: TObject);
    procedure DrawParametersAndTImage2;
    Procedure Calculation;
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

  TRectSource, TRectDestination: TRect;
  x, y, xx, yy: integer;
  zoom : integer;
  xPos,YPos : Integer;

  TempColor: TColor;

    ColorLabel: TColor;
    ValueOfRed,ValueOfGreen,ValueOfBlue: Byte;

    ZoomFactorX, ZoomFactorY : Real;


implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  //make sure the form is big enough to show all controls
  form1.top := 150;
  form1.left := 150;
  form1.width := 1550;
  form1.height := 860;

  y := 0;
  x :=  0;
  xx := Image2.Width;
  yy := Image2.Height;

  TRectDestination.Top := y;
  TRectDestination.Left := x;
  TRectDestination.Right := xx;
  TRectDestination.Bottom := yy;

  TRectSource.Top := 0;
  TRectSource.Left := 0;
  TRectSource.Right := Image1.Width;
  TRectSource.Bottom := Image1.Height;

  XPos := 50;
  YPos := 50;

  zoom :=  TrkZoom.Position;
  edtZoom.Caption := IntToStr(TrkZoom.position);

  ZoomFactorX := 100;
  ZoomFactorY := 100;

  Calculation;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  case Button of
    //mbRight: Form1.Memo1.Lines.Add('Right Mouse: '+IntToStr(x)+' '+IntToStr(y));
    mbLeft:  Begin

    //Read data from image
    ColorLabel := Image1.Picture.bitmap.Canvas.Pixels[X,Y];
    RedGreenBlue(ColorLabel,ValueOfRed,ValueOfGreen,ValueOfBlue); //single components
    Form1.Memo1.Lines.Add('Source Timage1 Left Mouse XPos : '+IntToStr(x)+' YPos : '+IntToStr(y)+' ColorLabel : '+IntToStr(ColorLabel)+' Red : '+IntToStr(ValueOfRed)+' Green : '+IntToStr(ValueOfGreen)+' Blue : '+IntToStr(ValueOfBlue));
  end;

   //mbMiddle: Form1.Memo1.Lines.Add('Middle Mouse: '+IntToStr(x)+' '+IntToStr(y));
  end;
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  case Button of
    //mbRight: Form1.Memo1.Lines.Add('Right Mouse: '+IntToStr(x)+' '+IntToStr(y));
    mbLeft: Begin

    //Read data from image
    ColorLabel := Image2.Picture.bitmap.Canvas.Pixels[X,Y];
    RedGreenBlue(ColorLabel,ValueOfRed,ValueOfGreen,ValueOfBlue); //single components
    Form1.Memo1.Lines.Add('Source Timage2 Left Mouse XPos : '+IntToStr(x)+' YPos : '+IntToStr(y)+' ColorLabel : '+IntToStr(ColorLabel)+' Red : '+IntToStr(ValueOfRed)+' Green : '+IntToStr(ValueOfGreen)+' Blue : '+IntToStr(ValueOfBlue));


    //mbMiddle: Form1.Memo1.Lines.Add('Middle Mouse: '+IntToStr(x)+' '+IntToStr(y));
    end;
  end;
end;

Procedure tform1.DrawParametersAndTImage2;
begin


  edtImageWidth.caption := IntToStr(Image1.Width);
  edtImageHeight.caption := IntToStr(Image1.Height);

  edtImage2Width.caption := IntToStr(Image2.Width);
  edtImage2Height.caption := IntToStr(Image2.Height);

  edtRTop.caption := IntToStr(TRectDestination.Top);
  edtRLeft.caption := IntToStr(TRectDestination.Left);
  edtRRight.caption := IntToStr(TRectDestination.Right);
  edtRBottom.caption := IntToStr(TRectDestination.Bottom);

  edtSourceRight.caption := IntToStr(TRectSource.Right);
  edtSourceBottom.caption := IntToStr(TRectSource.Bottom);

  edtXSize.Caption := IntToStr(XPos);
  edtYSize.Caption := IntToStr(YPos);
  edtZoom.Caption := IntToStr(Zoom);

  edtXFactor.caption := FormatFloat('###,###0.000',ZoomFactorX);
  edtYFactor.caption := FormatFloat('###,###0.000',ZoomFactorY);

  Image2.Canvas.Clear;
  Image2.Canvas.CopyRect(TRectDestination, Image1.Picture.Bitmap.Canvas, TRectSource);
end;

Procedure tform1.Calculation;
begin

  ZoomFactorX := XPos/zoom*100;
  ZoomFactorY := YPos/zoom*100;

  TRectDestination.Top := trunc(y * ZoomFactorY / 100);
  TRectDestination.Left := trunc(x * ZoomFactorX /100);
  TRectDestination.Right := trunc(xx * ZoomFactorX /100);
  TRectDestination.Bottom := trunc(yy * ZoomFactorY /100);



  DrawParametersAndTImage2;
end;

procedure TForm1.btnOpenClick(Sender: TObject);
Var
x,y : integer;
Bmp: TBitmap;
//Png: TPNGObject;
begin
  OpenDialog1.Execute;

  //Good for Win XP, but not good for Linux why ??
  //  if (OpenDialog1.Files.Count = 1) and (FileExistsUTF8(OpenDialog1.FileName)) then

  //alternative quick workaround because  (OpenDialog1.Files.Count = 1) gives always zero in my linux mint
  if (FileExistsUTF8(OpenDialog1.FileName))  then
  begin
    Image1.Picture.LoadFromFile(OpenDialog1.FileName);
  end else begin
    Memo1.Lines.Add('Open File Problem : '+OpenDialog1.FileName+' Files Count : '+IntToStr(OpenDialog1.Files.Count));
  end;
  Calculation;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  //draws just a rectangle for test

  with Image1.picture do
  begin
    Image1.Picture.bitmap.Canvas.Brush.Color:=clRed;
    Image1.Picture.bitmap.Canvas.Rectangle(100,100,300,300);
    Image1.Picture.bitmap.Canvas.Brush.Color:=clGreen;
    Image1.Picture.bitmap.Canvas.Rectangle(300,100,500,300);
    Image1.Picture.bitmap.Canvas.Brush.Color:=clBlue;
    Image1.Picture.bitmap.Canvas.Rectangle(500,100,700,300);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Image2.width := Image1.Width;
  Image2.height := Image1.Height;
  DrawParametersAndTImage2;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  TRectSource.Right := Image1.Width;
  TRectSource.Bottom := Image1.Height;
  DrawParametersAndTImage2;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  TRectDestination := TRectSource;
    DrawParametersAndTImage2;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin

  ZoomFactorX := 5;
  ZoomFactorY := 5;


  TRectDestination.Top := trunc(y * ZoomFactorY / 100);
  TRectDestination.Left := trunc(x * ZoomFactorX /100);
  TRectDestination.Right := trunc(xx * ZoomFactorX /100);
  TRectDestination.Bottom := trunc(yy * ZoomFactorY /100);



  //DrawParametersAndTImage2;
   DrawParametersAndTImage2;
end;

procedure TForm1.edtImage2WidthChange(Sender: TObject);
begin

end;

procedure TForm1.trkXSizeChange(Sender: TObject);
begin
  XPos := trkXSize.Position;
  Calculation;
end;

procedure TForm1.trkYSizeChange(Sender: TObject);
begin
 YPos := trkYSize.Position;
 Calculation;
end;

procedure TForm1.TrkZoomChange(Sender: TObject);
begin
  zoom :=  101-TrkZoom.Position;   //better not get zero
  calculation;
end;


end.

